package com.github.bluesbruce.ffch.handler;

import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.Map;

/**
 * 默认任务消息输出处理
 * @author eguid
 * @since jdk1.7
 * @version 2017年10月13日
 */
@Slf4j
public class DefaultOutHandlerMethod implements OutHandlerMethod{

	/**
	 * 任务是否异常中断，如果
	 */
	public boolean isBroken=false;
	public  static Map outIdMap = new HashMap();
	@Override
	public void parse(String id,String msg) {
		long begin = System.currentTimeMillis();
		//过滤消息
		if (msg.indexOf("fail") != -1) {
			log.info(id + "任务可能发生故障：" + msg);
			log.info("失败，设置中断状态");
			isBroken=true;
		}else if(msg.indexOf("miss")!= -1) {
			log.info(id + "任务可能发生丢包：" + msg);
			//log.info("失败，设置中断状态");
			//isBroken=true;
			isBroken=false;
		}else if(msg.indexOf("occurred")!= -1) {
			log.info(id + "任务可能发生丢包10054：" + msg);
			log.info("失败，设置中断状态");
			isBroken=false;
		}else if(msg.indexOf("Invalid")!= -1) {
			log.info(id + "任务可能发生非法响应：" + msg);
			log.info("失败，设置中断状态");
			isBroken=true;
		}else {
			isBroken=false;
			log.info(id + "消息：" + msg);
		}
		outIdMap.put(id,msg);
	}

	@Override
	public boolean isbroken() {
		return isBroken;
	}
	
}
